#include <iotiny2313.h>
#include <inavr.h>
#include "setting.h"
/*
 IAR C/C++ Compiler for AVR
 5.20.1 (5.20.1.50092)

    
 grezincmp@mail.ru
    .    setting.h
  01 
   .     

  02
    .     
*/
//   .    setting.h

/*   */
#define BIT(x)	              (1 << (x))
#define SETBIT(ADDRESS,BIT)   ((ADDRESS) |= (1<<(BIT)))
#define CLEARBIT(ADDRESS,BIT) ((ADDRESS) &= ~(1<<(BIT)))
#define BitIsSet(reg, bit)    ((reg & (1<<(bit))) != 0)
#define BitIsClear(reg, bit)  ((reg & (1<<(bit))) == 0)
/*        */
#define delay_us(us)	__delay_cycles ((unsigned char)(XTALL) * us);
#define delay_ms(ms)	delay_us (1000.0 * ms)

#define timelimitmax     timelimit+timelimit/100.0*dopuskpercent
#define timelimitmin     timelimit-timelimit/100.0*dopuskpercent

#ifdef COMMON_ANODE                            //     !
#define ON_a     CLEARBIT(seg_a_port,seg_a_pin)
#define ON_b     CLEARBIT(seg_b_port,seg_b_pin)
#define ON_c     CLEARBIT(seg_c_port,seg_c_pin)
#define ON_d     CLEARBIT(seg_d_port,seg_d_pin)
#define ON_e     CLEARBIT(seg_e_port,seg_e_pin)
#define ON_f     CLEARBIT(seg_f_port,seg_f_pin)
#define ON_g     CLEARBIT(seg_g_port,seg_g_pin)
#define OFF_a   SETBIT(seg_a_port,seg_a_pin)
#define OFF_b   SETBIT(seg_b_port,seg_b_pin)
#define OFF_c   SETBIT(seg_c_port,seg_c_pin)
#define OFF_d   SETBIT(seg_d_port,seg_d_pin)
#define OFF_e   SETBIT(seg_e_port,seg_e_pin)
#define OFF_f   SETBIT(seg_f_port,seg_f_pin)
#define OFF_g   SETBIT(seg_g_port,seg_g_pin)
#else                                         //     !
#define ON_a     SETBIT(seg_a_port,seg_a_pin)
#define ON_b     SETBIT(seg_b_port,seg_b_pin)
#define ON_c     SETBIT(seg_c_port,seg_c_pin)
#define ON_d     SETBIT(seg_d_port,seg_d_pin)
#define ON_e     SETBIT(seg_e_port,seg_e_pin)
#define ON_f     SETBIT(seg_f_port,seg_f_pin)
#define ON_g     SETBIT(seg_g_port,seg_g_pin)
#define OFF_a   CLEARBIT(seg_a_port,seg_a_pin)
#define OFF_b   CLEARBIT(seg_b_port,seg_b_pin)
#define OFF_c   CLEARBIT(seg_c_port,seg_c_pin)
#define OFF_d   CLEARBIT(seg_d_port,seg_d_pin)
#define OFF_e   CLEARBIT(seg_e_port,seg_e_pin)
#define OFF_f   CLEARBIT(seg_f_port,seg_f_pin)
#define OFF_g   CLEARBIT(seg_g_port,seg_g_pin)
#endif

#define starttimer0 TCCR0B=0x05 //  .  004
#define SetBuzer              SETBIT(buzer_port,buzer_pin)
#define ResetBuzer            CLEARBIT(buzer_port,buzer_pin)



#define starttimer1 TCCR1B = 0x05// c  1024
#define stoptimer1  TCCR1B = 0x00
#define resettimer1 TCNT1=0

__regvar __no_init unsigned char recive @ 5;
__regvar __no_init unsigned char blinkov @ 6;
__regvar __no_init unsigned char needchangeled @ 7;
__regvar __no_init unsigned char RXData @ 8;
__regvar __no_init unsigned char tip @ 9;
__regvar __no_init unsigned char tp @ 10;
__regvar __no_init unsigned char ti @ 11;
__regvar __no_init unsigned char start @ 12;
__regvar __no_init unsigned char stop @ 13;
__regvar __no_init unsigned char numbit @ 14;
__regvar __no_init unsigned char rx_data @ 15;

__flash unsigned char cod[]={64,121,36,48,25,18,2,120,0,16,8,3,70,33,6,14,127};

unsigned char blinkbuffer[4]={16,16,16,16};

void initbuzer(void)
{
CLEARBIT(buzer_port,buzer_pin);//    
SETBIT(buzer_ddr,buzer_pin);   //    
}


void beep(void)                //  ,    
{
unsigned char cykl=beeplength;;
while (cykl--)
      {
      SetBuzer; 
      delay_us(beepimpulstime);
      ResetBuzer;
      delay_us(beepimpulpausestime); 
      } 
}


void initled(void)            //   ,          
{
 OFF_a; SETBIT(seg_a_ddr,seg_a_pin);
 OFF_b; SETBIT(seg_b_ddr,seg_b_pin);
 OFF_c; SETBIT(seg_c_ddr,seg_c_pin);
 OFF_d; SETBIT(seg_d_ddr,seg_d_pin);
 OFF_e; SETBIT(seg_e_ddr,seg_e_pin);
 OFF_f; SETBIT(seg_f_ddr,seg_f_pin);
 OFF_g; SETBIT(seg_g_ddr,seg_g_pin);
}

void inittimer1(void)
{
stoptimer1;           // TCCR1B = 0x00; //stop timer
OCR1A  = 3905;        //set compare value 500ms c  1024    8.2 
resettimer1;          //  
TCCR1A = 0x00;        // .
SETBIT(TIMSK,OCIE1A); //  TIMER1_COMPA
blinkov=0;            //    
}

void printznak(unsigned char znak)// 0..15 16- !
{//   .        
 if BitIsSet(cod[znak],0) OFF_a; else ON_a;
 if BitIsSet(cod[znak],1) OFF_b; else ON_b;
 if BitIsSet(cod[znak],2) OFF_c; else ON_c;
 if BitIsSet(cod[znak],3) OFF_d; else ON_d;
 if BitIsSet(cod[znak],4) OFF_e; else ON_e;
 if BitIsSet(cod[znak],5) OFF_f; else ON_f;
 if BitIsSet(cod[znak],6) OFF_g; else ON_g;
}

#pragma vector=PCIN1_vect
__interrupt void Pin_Change_interrupt( void )
{
/*
   - 4  (0101) +  + 1  (0)      
                       4  (1010) +  + 1  (1)       
  -     ==1      ==0
      ,  ,       
   (timelimit)   .
   -     
*/
# ifndef invinput
if BitIsSet(PINB, 0) 
  {
   tp=TCNT0; // .       ti/tp (  !)
   TCNT0=0;  //  
  #ifdef timelimit
     unsigned int tl;
     tl=ti+tp;                                     //,       
     if ((tl>timelimitmin) &&   (tl<timelimitmax)) //     ,  
                                                   //,     numbit
    #endif //timelimit
   {
   if (ti<tp) //     ,
      {
        if ((tp-ti-ti)<0) tip=0; else { //         ,                          
                                       tip=3;                  // =0
                                       if (numbit==0) start=0; //   
                                       if (numbit==8) stop=0;  //   
                                      } 
      }
   else  
      {//     , 
        if ((ti-tp-tp)<0)  tip=1; else {//         ,   
                                        tip=3;                  // =1
                                        if (numbit==0) start=1; //   
                                        if (numbit==8) stop=1;  //   
                                       } 
      }   
       if (tip==3)
                {                                          //   
                 if ((numbit==8) & (start==1) & (stop==0)) //     
                    {recive=1;RXData=rx_data; }            //   8 ,     ()  
                                                           //    ()    
                 numbit=0;// , ,    ! 
                }
         else//   
         {
          rx_data=rx_data*2; numbit++;//     
          if (tip==0) CLEARBIT(rx_data,0); else SETBIT(rx_data,0);//  
         } 
      }// ti/tp
       #ifdef timelimit
       else numbit=0; //    
       #endif //timelimit
   //     timelimit
  }
else  { ti=TCNT0; TCNT0=0; }// .     
}



#else //   
if BitIsClear(PINB, 0) 
  {
   ti=TCNT0; // .       ti/tp (  !)
   TCNT0=0;  //  
  #ifdef timelimit
     unsigned int tl;
     tl=ti+tp;                                    //,       
     if ((tl>timelimitmin) &   (tl<timelimitmax)) //     ,  
                                                   //,     numbit
    #endif //timelimit
   {
   if (ti<tp)  //     ,
      {
        if ((tp-ti-ti)<0) tip=1; else { //         ,   
                                       tip=3;                  // =1
                                       if (numbit==0) start=1; //   
                                       if (numbit==8) stop=1;  //   
                                      } 
      }
   else  
      {//     , 
        if ((ti-tp-tp)<0)  tip=0; else {//         ,   
                                        tip=3;                  // =0
                                        if (numbit==0) start=0; //   
                                        if (numbit==8) stop=0;  //   
                                       } 
      }   
       if (tip==3)
                {                                          //   
                 if ((numbit==8) & (start==1) & (stop==0)) //     
                    {recive=1;RXData=rx_data; }                //   8 ,     ()  
                                                           //    ()    
                 numbit=0;// , ,    ! 
                }
         else//   
         {
          rx_data=rx_data*2; numbit++;//     
          if (tip==0) CLEARBIT(rx_data,0); else SETBIT(rx_data,0);//  
         } 
      }// ti/tp
       #ifdef timelimit
       else numbit=0; //    
       #endif //timelimit
   //     timelimit
  }
else  { tp=TCNT0; TCNT0=0; }// .     
}
#endif


void initreciver(void)
{
CLEARBIT(PCINT0_PORT,PCINT0_PIN); // !!! 
CLEARBIT(PCINT0_DDR,PCINT0_PIN);  // !!!
GIMSK=(1<<PCIE);                  //  PCINT
PCMSK=(1<<PCINT0);                //    PCINT0
recive=0;                         //   
starttimer0;
}


#pragma vector=TIMER1_COMPA_vect
__interrupt void TIMER1_compareA_interrupt( void )
{                                  // 500 
  resettimer1;                     //  
  blinkov--;
  if (blinkov==0) stoptimer1;      // . 
     else needchangeled=1;         //      (   )
}


void showsignalizator(void)
{static unsigned char index;
printznak(blinkbuffer[index]);       //   
index=(index+1) & 3;                 //     3
if (blinkbuffer[index]==16) index=0; //  .
}


void prepareblinkbuffer(unsigned char datarx)
{ unsigned char d;
  for(unsigned char i=0; i<4; i++)  
  {
    d=blinkbuffer[i];
    if (d==datarx) break;                    //      
    if (d==16) {blinkbuffer[i]=datarx;i=4;}  //         
  }
resettimer1;                                 //    
starttimer1;
blinkov=BlinkCount;                          //  ,      
needchangeled=1;                             //    ( )     
showsignalizator();                          // 
beep();                                      //   
}


void resetblinkbuffer(void)
{
printznak(16);                                        //   
for(unsigned char i=0; i<4; i++)   blinkbuffer[i]=16; //   ""  
}

void initport_s(void)
{
 PORTA=0; // .      .
 PORTB=0; //    .
 PORTD=0; //     .
 DDRA=0x07;
 DDRB=0xFE;
 DDRD=0x7F;
}

void main( void )
{
__disable_interrupt();
initport_s();              //        0
initbuzer();               //   
initled();                 //  ,    
ON_a; delay_ms(100);OFF_a; //       
ON_b; delay_ms(100);OFF_b;
ON_c; delay_ms(100);OFF_c;
ON_d; delay_ms(100);OFF_d;
ON_e; delay_ms(100);OFF_e;
ON_f; delay_ms(100);OFF_f;
ON_g; delay_ms(100);OFF_g;
printznak(16);             //   
beep();                    //  ,  -     
initreciver();             //    PCINT0        PCINT0  TIMER0
inittimer1();              //      500    TIMER1_COMPA
__enable_interrupt();      //        .
while(1)
 {
  if (recive==1)                                          //   
      {
        recive=0;                                         //    
        if ((RXData>>4)==(RXData & 0x0F))                 //     0..15   
        prepareblinkbuffer(RXData & 0x0F);                //   ,        
      }
  if (blinkov!=0)                                         //      
         {
           if (needchangeled==1)                          //      500
           {
           needchangeled=0;                               //    
           if ( BitIsSet(blinkov,0) ) showsignalizator(); //   -   ,    () 
           else  printznak(16);                           //  
           }
         } 
     else  {resetblinkbuffer();}                          //  .     .
 }
}

